import java.io.*;
import java.util.Date;
import java.awt.Color;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;
import java.util.Vector;
import java.util.Enumeration;
import java.text.DateFormat;
import java.sql.*;
import javax.servlet.http.*;
import javax.servlet.*;
import com.lowagie.text.*;
import com.lowagie.text.pdf.PdfWriter;
import com.lowagie.text.rtf.RtfWriter;
import com.lowagie.text.pdf.BaseFont;

public class List14 extends HttpServlet {
    private static String db_url = "jdbc:db2:newdb";
    private static String db_driver = "COM.ibm.db2.jdbc.app.DB2Driver";
    private static String db_user = "user";
    private static String db_password = "password";
    private Connection conn =null;
    private static Font small_font = new Font(Font.HELVETICA,8);

   DateFormat df = DateFormat.getDateTimeInstance(DateFormat.MEDIUM,
						   DateFormat.MEDIUM,
						   Locale.JAPAN);

    public void init(ServletConfig config) throws ServletException {
        super.init(config);
	//^C][̎w
	df.setTimeZone(TimeZone.getTimeZone("JST"));
	try{
	    //DBhCõ[h
	    Class.forName(db_driver);
	    //DB̐ڑ
	    conn = DriverManager.getConnection(db_url,db_user,db_password);
	} catch (ClassNotFoundException e){
	    System.err.println("ERR- hCo܂");
	} catch(SQLException e){
	    System.err.println("ERR- DB̐ڑɎs܂");
	}
    }

    protected void processRequest(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, java.io.IOException {
        
        //NGXgEp[^擾
        String doc_format = req.getParameter("doc_format");
        
        //hLgEIuWFNg̐
        Document document = new Document(PageSize.A4, 20, 20, 40, 36);
        
        try {
            //*WriterIuWFNg̐
            if ("pdf".equals(doc_format)) {
                res.setContentType("application/pdf");
                PdfWriter.getInstance(document, res.getOutputStream());
            }
            else if ("rtf".equals(doc_format)) {
                res.setContentType("text/rtf");
                RtfWriter.getInstance(document, res.getOutputStream());
            }
            else {
                errorPage(res);
           }
            
            //hLgOPEN
	    HeaderFooter header = new HeaderFooter(new Phrase(df.format(new Date())), false);
	    HeaderFooter footer = new HeaderFooter(new Phrase("page "), new Phrase("."));
	    footer.setAlignment(Element.ALIGN_CENTER);
	    document.setHeader(header);
	    document.setFooter(footer);
            document.open();
            
            //Rec̐
            Table datatable = getTable();
            document.add(datatable);

        }catch(DocumentException de){
            System.err.println(de.getMessage());
        }catch(Exception e){
            System.err.println(e.getMessage());
        }
        
        //hLgCLOSE
        document.close();
    }

     protected void doGet(HttpServletRequest req, HttpServletResponse res)
                            throws ServletException, java.io.IOException {
        processRequest(req, res);
    } 

    protected void doPost(HttpServletRequest req, HttpServletResponse res)
                            throws ServletException, java.io.IOException {
        processRequest(req, res);
    }

    private Table getTable() throws BadElementException, DocumentException, IOException {

        //e[ů{ݒ
        Table aTable = new Table(4);
	aTable.setDefaultHorizontalAlignment(Element.ALIGN_CENTER);
	aTable.setDefaultVerticalAlignment(Element.ALIGN_MIDDLE);
	aTable.setPadding(2);
	aTable.setSpacing(0);
        int widths[] = {5,70,10,15};
        aTable.setWidths(widths);
        aTable.setWidth(93);

        //wb_[ݒ
        BaseFont bf = BaseFont.createFont("HeiseiKakuGo-W5", "UniJIS-UCS2-HW-H",false);
	Font font = new Font(bf, 8);
        Cell cell = new Cell(new Phrase("Ǘ҃j[iUSER_AGENTLO)", font));
        cell.setColspan(4);
        cell.setBackgroundColor(new Color(0xC0, 0xC0, 0xC0));
        aTable.addCell(cell);
        aTable.addCell(new Phrase("",font));
        aTable.addCell(new Phrase("uEU",font));
        aTable.addCell(new Phrase("ANZX",font));
        aTable.addCell(new Phrase("ŏIANZX",font));
        aTable.endHeaders();
        
        //f[^̊i[
	aTable.setDefaultHorizontalAlignment(Element.ALIGN_LEFT);
        for(Enumeration e = getContents().elements();e.hasMoreElements();){
            aTable.addCell(new Phrase((String)e.nextElement(), small_font));
        }
        return aTable;
    }
    
    private Vector getContents(){
                Vector contents = new Vector();
	    try{
		//DBڑ
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt.executeQuery("SELECT * FROM USER_AGENT ORDER BY REF_LEVEL DESC");
		ResultSetMetaData meta = rs.getMetaData();
		//\̃ZɑΉf[^𐮗񂵂Ċi[
               long row_count = 1;
		while (rs.next ()) {
		    for (int i=0; i < meta.getColumnCount(); i++) {
                        //s̃JEgƋL^
                        if(i==0){
                            contents.addElement(Long.toString(row_count));
                            row_count++;
                       }
                        //f[^̒oƊi[
			Object cell_obj = rs.getObject(i+1);
                        contents.addElement(cell_obj.toString());
		    }
		}
		rs.close(); rs = null;
                stmt.close(); stmt = null;
	    } catch (Exception e){
		System.err.println("DBɖ肪܂");
		System.err.println(e.getMessage());
	    }
            return contents;
    }

    protected void errorPage(HttpServletResponse res) throws IOException{
          res.sendRedirect("http://127.0.0.1:8080/error.html");
          System.err.println("p[^tăNGXgĉ");
          System.err.println("Ex:  http://127.0.0.1:8080/servlet/List14?doc_format=pdf");
    }
}